/*
*  Copyright 2016 Fabien Bourgeois <fabien@yaltik.com>
* 
*  This program is free software: you can redistribute it and/or modify it
*  under the terms of the GNU Affero General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or (at your
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but WITHOUT
*  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
*  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
*  License for more details.
* 
*  You should have received a copy of the GNU Affero General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* global openerp */

openerp.web_widget_phone_check_fr = function (instance) {
  'use strict';

  var rePhone = /^\d{10}$/;

  openerp.web.form.FieldPhoneFr =
    instance.web.form.FieldChar.extend({
      template: 'FieldEmail',
      is_syntax_valid: function () {
        var val = this.$('input').val() || '';
        return ((val.length === 0) || rePhone.test(val));
      },
      render_value: function() {
        if (!this.get('effective_readonly')) {
          this._super();
        } else {
          var val = this.get('value') || '';
          this.$el.find('a').attr('href', 'tel:' + val).text(val);
        }
      }
    });

    instance.web.form.widgets.add('phonefr', 'instance.web.form.FieldPhoneFr');
};
